Index: pjproject/trunk/pjlib-util/build/Makefile
===================================================================
--- pjproject/trunk/pjlib-util/build/Makefile	(revision 898)
+++ pjproject/trunk/pjlib-util/build/Makefile	(revision 992)
@@ -28,5 +28,5 @@
 export PJLIB_UTIL_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
 		errno.o dns.o dns_dump.o getopt.o md5.o resolver.o \
-		scanner.o stun.o string.o stun_client.o xml.o
+		scanner.o string.o stun_simple.o stun_simple_client.o xml.o
 export PJLIB_UTIL_CFLAGS += $(_CFLAGS)
 
Index: pjproject/trunk/pjlib-util/build/pjlib_util.dsp
===================================================================
--- pjproject/trunk/pjlib-util/build/pjlib_util.dsp	(revision 898)
+++ pjproject/trunk/pjlib-util/build/pjlib_util.dsp	(revision 992)
@@ -130,9 +130,25 @@
 # Begin Source File
 
-SOURCE="..\src\pjlib-util\stun.c"
-# End Source File
-# Begin Source File
-
-SOURCE="..\src\pjlib-util\stun_client.c"
+SOURCE="..\src\pjlib-util\stun_endpoint.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\stun_msg.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\stun_server.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\stun_simple.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\stun_simple_client.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\stun_transaction.c"
 # End Source File
 # Begin Source File
@@ -194,5 +210,25 @@
 # Begin Source File
 
-SOURCE="..\include\pjlib-util\stun.h"
+SOURCE="..\include\pjlib-util\stun_doc.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\stun_endpoint.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\stun_msg.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\stun_server.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\stun_simple.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\stun_transaction.h"
 # End Source File
 # Begin Source File
Index: pjproject/trunk/pjlib-util/build/pjlib_util.dsw
===================================================================
--- pjproject/trunk/pjlib-util/build/pjlib_util.dsw	(revision 898)
+++ pjproject/trunk/pjlib-util/build/pjlib_util.dsw	(revision 992)
@@ -20,8 +20,4 @@
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject/pjlib/build", UIAAAAAA
-    ..\..\pjlib\build
-    end source code control
 }}}
 
@@ -62,4 +58,22 @@
 ###############################################################################
 
+Project: "pjstun_srv"=".\pjstun_srv.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+    Begin Project Dependency
+    Project_Dep_Name pjlib
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjlib_util
+    End Project Dependency
+}}}
+
+###############################################################################
+
 Global:
 
Index: pjproject/trunk/pjlib-util/build/pjlib_util.vcproj
===================================================================
--- pjproject/trunk/pjlib-util/build/pjlib_util.vcproj	(revision 898)
+++ pjproject/trunk/pjlib-util/build/pjlib_util.vcproj	(revision 992)
@@ -400,46 +400,10 @@
 			</File>
 			<File
-				RelativePath="..\src\pjlib-util\stun.c"
-				>
-				<FileConfiguration
-					Name="Release|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Debug|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
-			</File>
-			<File
-				RelativePath="..\src\pjlib-util\stun_client.c"
-				>
-				<FileConfiguration
-					Name="Release|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Debug|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
+				RelativePath="..\src\pjlib-util\stun_simple.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjlib-util\stun_simple_client.c"
+				>
 			</File>
 			<File
@@ -537,5 +501,5 @@
 			</File>
 			<File
-				RelativePath="..\include\pjlib-util\stun.h"
+				RelativePath="..\include\pjlib-util\stun_simple.h"
 				>
 			</File>
Index: pjproject/trunk/pjlib-util/build/pjstun_srv.dsp
===================================================================
--- pjproject/trunk/pjlib-util/build/pjstun_srv.dsp	(revision 992)
+++ pjproject/trunk/pjlib-util/build/pjstun_srv.dsp	(revision 992)
@@ -0,0 +1,106 @@
+# Microsoft Developer Studio Project File - Name="pjstun_srv" - Package Owner=<4>
+# Microsoft Developer Studio Generated Build File, Format Version 6.00
+# ** DO NOT EDIT **
+
+# TARGTYPE "Win32 (x86) Console Application" 0x0103
+
+CFG=pjstun_srv - Win32 Debug
+!MESSAGE This is not a valid makefile. To build this project using NMAKE,
+!MESSAGE use the Export Makefile command and run
+!MESSAGE 
+!MESSAGE NMAKE /f "pjstun_srv.mak".
+!MESSAGE 
+!MESSAGE You can specify a configuration when running NMAKE
+!MESSAGE by defining the macro CFG on the command line. For example:
+!MESSAGE 
+!MESSAGE NMAKE /f "pjstun_srv.mak" CFG="pjstun_srv - Win32 Debug"
+!MESSAGE 
+!MESSAGE Possible choices for configuration are:
+!MESSAGE 
+!MESSAGE "pjstun_srv - Win32 Release" (based on "Win32 (x86) Console Application")
+!MESSAGE "pjstun_srv - Win32 Debug" (based on "Win32 (x86) Console Application")
+!MESSAGE 
+
+# Begin Project
+# PROP AllowPerConfigDependencies 0
+# PROP Scc_ProjName ""
+# PROP Scc_LocalPath ""
+CPP=cl.exe
+RSC=rc.exe
+
+!IF  "$(CFG)" == "pjstun_srv - Win32 Release"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 0
+# PROP BASE Output_Dir "./output/pjstun-srv-i386-win32-vc6-release"
+# PROP BASE Intermediate_Dir "./output/pjstun-srv-i386-win32-vc6-release"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 0
+# PROP Output_Dir "./output/pjstun-srv-i386-win32-vc6-release"
+# PROP Intermediate_Dir "./output/pjstun-srv-i386-win32-vc6-release"
+# PROP Ignore_Export_Lib 0
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "../include" /I "../../pjlib/include" /D "NDEBUG" /D "WIN32" /D "_CONSOLE" /D "_MBCS" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /YX /FD /c
+# ADD BASE RSC /l 0x409 /d "NDEBUG"
+# ADD RSC /l 0x409 /d "NDEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LINK32=link.exe
+# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
+# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386 /out:"../bin/pjstun-srv-i386-win32-vc6-release.exe"
+
+!ELSEIF  "$(CFG)" == "pjstun_srv - Win32 Debug"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 1
+# PROP BASE Output_Dir "./output/pjstun-srv-i386-win32-vc6-debug"
+# PROP BASE Intermediate_Dir "./output/pjstun-srv-i386-win32-vc6-debug"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 1
+# PROP Output_Dir "./output/pjstun-srv-i386-win32-vc6-debug"
+# PROP Intermediate_Dir "./output/pjstun-srv-i386-win32-vc6-debug"
+# PROP Ignore_Export_Lib 0
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /GZ /c
+# ADD CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /D "_DEBUG" /D "WIN32" /D "_CONSOLE" /D "_MBCS" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /YX /FD /GZ /c
+# ADD BASE RSC /l 0x409 /d "_DEBUG"
+# ADD RSC /l 0x409 /d "_DEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LINK32=link.exe
+# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
+# ADD LINK32 netapi32.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /out:"../bin/pjstun-srv-i386-win32-vc6-debug.exe" /pdbtype:sept
+
+!ENDIF 
+
+# Begin Target
+
+# Name "pjstun_srv - Win32 Release"
+# Name "pjstun_srv - Win32 Debug"
+# Begin Group "Source Files"
+
+# PROP Default_Filter "cpp;c;cxx;rc;def;r;odl;idl;hpj;bat"
+# Begin Source File
+
+SOURCE="..\src\pjstun-srv\server_main.c"
+# End Source File
+# End Group
+# Begin Group "Header Files"
+
+# PROP Default_Filter "h;hpp;hxx;hm;inl"
+# Begin Source File
+
+SOURCE="..\src\pjstun-srv\server.h"
+# End Source File
+# End Group
+# Begin Group "Resource Files"
+
+# PROP Default_Filter "ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe"
+# End Group
+# End Target
+# End Project